Re: [PATCH v7 10/10] perf test: Add direct off-cpu test

From: Ian Rogers
Date: Mon Nov 11 2024 - 13:09:25 EST


On Fri, Nov 8, 2024 at 12:42 PM Howard Chu <howardchu95@xxxxxxxxx> wrote:
>
> Why is there a --off-cpu-thresh 2000000?
>
> We collect an off-cpu period __ONLY ONCE__, either in direct sample form,
> or in accumulated form (in BPF stack trace map). If I don't add
> --off-cpu-thresh 200000, the sample in the original test goes into the
> ring buffer instead of the BPF stack trace map. Additionally, when using
> -e dummy, the ring buffer is not open, causing us to lose a sample.

Lgtm, could we move some of this commit message into a comment in the
code. Often refactoring will move things around making hunting for
appropriate comments like this a challenge.

Thanks,
Ian

> Signed-off-by: Howard Chu <howardchu95@xxxxxxxxx>
> ---
> tools/perf/tests/builtin-test.c | 1 +
> tools/perf/tests/shell/record_offcpu.sh | 31 ++++++++++++++++++++++++-
> tools/perf/tests/tests.h | 1 +
> tools/perf/tests/workloads/Build | 1 +
> tools/perf/tests/workloads/offcpu.c | 16 +++++++++++++
> 5 files changed, 49 insertions(+), 1 deletion(-)
> create mode 100644 tools/perf/tests/workloads/offcpu.c
>
> diff --git a/tools/perf/tests/builtin-test.c b/tools/perf/tests/builtin-test.c
> index d2cabaa8ad92..2228e6064d16 100644
> --- a/tools/perf/tests/builtin-test.c
> +++ b/tools/perf/tests/builtin-test.c
> @@ -145,6 +145,7 @@ static struct test_workload *workloads[] = {
> &workload__brstack,
> &workload__datasym,
> &workload__landlock,
> + &workload__offcpu,
> };
>
> #define workloads__for_each(workload) \
> diff --git a/tools/perf/tests/shell/record_offcpu.sh b/tools/perf/tests/shell/record_offcpu.sh
> index 678947fe69ee..fda1c1ad4555 100755
> --- a/tools/perf/tests/shell/record_offcpu.sh
> +++ b/tools/perf/tests/shell/record_offcpu.sh
> @@ -6,6 +6,10 @@ set -e
>
> err=0
> perfdata=$(mktemp /tmp/__perf_test.perf.data.XXXXX)
> +TEST_PROGRAM="perf test -w offcpu"
> +
> +ts=$(printf "%u" $((~0 << 32))) # OFF_CPU_TIMESTAMP
> +dummy_timestamp=${ts%???} # remove the last 3 digits to match perf script
>
> cleanup() {
> rm -f ${perfdata}
> @@ -39,7 +43,7 @@ test_offcpu_priv() {
> test_offcpu_basic() {
> echo "Basic off-cpu test"
>
> - if ! perf record --off-cpu -e dummy -o ${perfdata} sleep 1 2> /dev/null
> + if ! perf record --off-cpu --off-cpu-thresh 2000000 -e dummy -o ${perfdata} sleep 1 2> /dev/null
> then
> echo "Basic off-cpu test [Failed record]"
> err=1
> @@ -88,6 +92,27 @@ test_offcpu_child() {
> echo "Child task off-cpu test [Success]"
> }
>
> +test_offcpu_direct() {
> + echo "Direct off-cpu test"
> +
> + # dump off-cpu samples for task blocked for more than 1.999999s
> + # -D for initial delay, to enable evlist
> + if ! perf record -e dummy -D 500 --off-cpu --off-cpu-thresh 1999999 -o ${perfdata} ${TEST_PROGRAM} 2> /dev/null
> + then
> + echo "Direct off-cpu test [Failed record]"
> + err=1
> + return
> + fi
> + # Direct sample's timestamp should be lower than the dummy_timestamp of the at-the-end sample.
> + if ! perf script -i ${perfdata} -F time,period | sed "s/[\.:]//g" | \
> + awk "{ if (\$1 < ${dummy_timestamp} && \$2 > 1999999999) exit 0; else exit 1; }"
> + then
> + echo "Direct off-cpu test [Failed missing direct sample]"
> + err=1
> + return
> + fi
> + echo "Direct off-cpu test [Success]"
> +}
>
> test_offcpu_priv
>
> @@ -99,5 +124,9 @@ if [ $err = 0 ]; then
> test_offcpu_child
> fi
>
> +if [ $err = 0 ]; then
> + test_offcpu_direct
> +fi
> +
> cleanup
> exit $err
> diff --git a/tools/perf/tests/tests.h b/tools/perf/tests/tests.h
> index af284dd47e5c..58de36e0edc5 100644
> --- a/tools/perf/tests/tests.h
> +++ b/tools/perf/tests/tests.h
> @@ -216,6 +216,7 @@ DECLARE_WORKLOAD(sqrtloop);
> DECLARE_WORKLOAD(brstack);
> DECLARE_WORKLOAD(datasym);
> DECLARE_WORKLOAD(landlock);
> +DECLARE_WORKLOAD(offcpu);
>
> extern const char *dso_to_test;
> extern const char *test_objdump_path;
> diff --git a/tools/perf/tests/workloads/Build b/tools/perf/tests/workloads/Build
> index 5af17206f04d..0e78fd01eaf1 100644
> --- a/tools/perf/tests/workloads/Build
> +++ b/tools/perf/tests/workloads/Build
> @@ -7,6 +7,7 @@ perf-test-y += sqrtloop.o
> perf-test-y += brstack.o
> perf-test-y += datasym.o
> perf-test-y += landlock.o
> +perf-test-y += offcpu.o
>
> CFLAGS_sqrtloop.o = -g -O0 -fno-inline -U_FORTIFY_SOURCE
> CFLAGS_leafloop.o = -g -O0 -fno-inline -fno-omit-frame-pointer -U_FORTIFY_SOURCE
> diff --git a/tools/perf/tests/workloads/offcpu.c b/tools/perf/tests/workloads/offcpu.c
> new file mode 100644
> index 000000000000..57cee201a4c3
> --- /dev/null
> +++ b/tools/perf/tests/workloads/offcpu.c
> @@ -0,0 +1,16 @@
> +#include <linux/compiler.h>
> +#include <unistd.h>
> +#include "../tests.h"
> +
> +static int offcpu(int argc __maybe_unused, const char **argv __maybe_unused)
> +{
> + /* get past the initial delay */
> + sleep(1);
> +
> + /* what we want to collect as a direct sample */
> + sleep(2);
> +
> + return 0;
> +}
> +
> +DEFINE_WORKLOAD(offcpu);
> --
> 2.43.0
>